#!/bin/bash -ex 

#echo $$
source_dir=`pwd`
base_dir=${source_dir##*/}
pkg_name=kgwttm
commit_id='nogit'

uname=`uname -r`
kernel_ver=`./kmodtool verrel $uname`
short_ker_ver=`echo $uname | perl -pe 's/(\d+\.\d+\.\d+\-\d+).*/\1/'`
short_ker_ver=`echo $short_ker_ver | perl -pe 's/-/_/g'`

echo 'change release to ' $commit_id
#sed -i 's/\(Release: \).*/\1'$commit_id''.''$short_ker_ver'/g' ${pkg_name}.spec

if [ -d ~/rpmbuild_$$/ ]; then
    echo 'rerun the build.sh'
    exit -1
fi

chmod +x ${pkg_name}.modules

mkdir -p ~/rpmbuild_$$/{BUILD,BUILDROOT,SOURCES,SPECS,RPMS,SRPMS}
echo '%_topdir %(echo $HOME)/rpmbuild_'$$ > ~/.rpmmacros

cd ~/rpmbuild_$$/SOURCES
tar -czf ${pkg_name}.tar.gz -C ${source_dir%/*} ${base_dir}

cd ~/rpmbuild_$$/BUILD
cp ${source_dir}/${pkg_name}.modules .
cp ${source_dir}/kgwttm-insmod.sh .

cd ~/rpmbuild_$$/SPECS
cp ${source_dir}/${pkg_name}.spec .

rpmbuild -v -bb ${pkg_name}.spec  --target `uname -m` --define='kversion '$kernel_ver --define='srcdir '${source_dir} 

cd ${source_dir}
if [ -e ~/rpmbuild_$$/RPMS/`uname -m`/ ]; then
    echo 'rpm build success'
    cp ~/rpmbuild_$$/RPMS/`uname -m`/*.rpm .
fi

#rm -rf ~/rpmbuild_$$
#rm ~/.rpmmacros
