#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <arpa/inet.h>
#include "ttm_user.h"

int main(int argc, char *argv[])
{
    int sockfd,new_fd;
    struct sockaddr_in server_addr;
    struct sockaddr_in client_addr;
    int sin_size,portnumber;
    char hello[1000]="Hello! Are You Fine?\n";
    
    if(argc!=2) {
        fprintf(stderr,"Usage:%s portnumber\a\n",argv[0]);
        exit(1);
    }
    
    if((portnumber=atoi(argv[1]))<0) {
        fprintf(stderr,"Usage:%s portnumber\a\n",argv[0]);
        exit(1);
    }
    
    if((sockfd=socket(AF_INET,SOCK_STREAM,0))==-1) {
        fprintf(stderr,"Socket error:%s\n\a",strerror(errno));
        exit(1);
    }
    
    bzero(&server_addr,sizeof(struct sockaddr_in));
    server_addr.sin_family=AF_INET;
    server_addr.sin_addr.s_addr=htonl(INADDR_ANY);
    server_addr.sin_port=htons(portnumber);
    
    if(bind(sockfd,(struct sockaddr *)(&server_addr),
        sizeof(struct sockaddr))==-1) {
        fprintf(stderr,"Bind error:%s\n\a",strerror(errno));
        exit(1);
    }
    
    if(listen(sockfd,5)==-1) {
        fprintf(stderr,"Listen error:%s\n\a",strerror(errno));
        exit(1);
    }
    
    while(1) {
        struct ttm_peer peer;
        int len;
        char addr_string[128];
        
        len = sizeof(peer);
    
        sin_size=sizeof(struct sockaddr_in);
        if((new_fd=accept(sockfd,(struct sockaddr *)&client_addr, &sin_size))==-1) {
            fprintf(stderr,"Accept error:%s\n\a",strerror(errno));
            exit(1);
        }
		
    	/* 4to4: cip&cport here */
		/* 6to4: bip&bport here */
        fprintf(stderr,"Server get connection from %s:%u\n",
            inet_ntoa(client_addr.sin_addr),
            ntohs(client_addr.sin_port));

		/* 4to4: cip&cport here */
		/* 6to4: cip&cport here */
        if (getsockopt(new_fd, IPPROTO_IP, TTM_SO_GET_PEER, &peer, &len) < 0) {
            fprintf(stderr, "getsockopt failed\n");
        } else {
            inet_ntop(peer.af, &peer.all, &addr_string, sizeof(addr_string));
            printf("getsockopt success(addr:%s  port:%u)\n", addr_string, ntohs(peer.port));
        }
     
        close(new_fd);
    }
    close(sockfd);
    exit(0);
}


