# Define the kmod package name here.
%define kmod_name kgwttm
%define file_name kgwttm

AutoReqProv: no

# If kversion isn't defined on the rpmbuild line, define it here.
%{!?kversion: %define kversion "2.6.32-573.26.1.el6.KScdn1_0.x86_64"}

Name:    %{kmod_name}-kmod
Version: 2.6.32_573
Release: 1.0.0.0
Group:   System Environment/Kernel
License: GPLv2
Summary: %{kmod_name} kernel module(s)
URL:     http://www.centos.org/

BuildRequires: redhat-rpm-config
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-build-%(%{__id_u} -n)
ExclusiveArch: x86_64

# Sources.
Source0:  %{kmod_name}.tar.gz

%define kmod_version %{version}
%define kmod_release %{release}

# Define the variants for each architecture.
%define basevar ""

# If kvariants isn't defined on the rpmbuild line, build all variants for this architecture.
%{!?kvariants: %define kvariants %{?basevar} }

# Magic hidden here.
%{expand:%(sh %{srcdir}/kmodtool rpmtemplate %{kmod_name} %{kversion} %{kvariants})}

%define __debug_install_post \
  /usr/lib/rpm/find-debuginfo.sh %{_builddir}/%{?buildsubdir}\
  %{nil}

# Define the filter.
%define __find_requires sh %{_builddir}/%{buildsubdir}/filter-requires.sh

%description

%prep
%setup -q -c -T -a 0
%{__cp} -a %{kmod_name} _kmod_build_
#echo "/usr/lib/rpm/redhat/find-requires | %{__sed} -e '/^ksym.*/d'" > filter-requires.sh
echo "override %{file_name} * extra/%{kmod_name}" > kmod-%{kmod_name}.conf

%build
KSRC=%{_usrsrc}/kernels/%{kversion}
%{__make} -C "${KSRC}" modules M=$PWD/_kmod_build_

%install
%{__rm} -rf %{buildroot}
kernel_dir=%{buildroot}/lib/modules/%{kversion}
%{__install} -d ${kernel_dir}/extra/%{kmod_name}
%{__install} $PWD/_kmod_build_/%{file_name}.ko ${kernel_dir}/extra/%{kmod_name}

%{__install} -d %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} kmod-%{kmod_name}.conf %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} -d %{buildroot}%{_sysconfdir}/sysconfig/modules/
%{__install} -d %{buildroot}%{_usr}/local/bin
%{__install} %{_builddir}/%{kmod_name}.modules  %{buildroot}%{_sysconfdir}/sysconfig/modules/
%{__install} %{_builddir}/kgwttm-insmod.sh  %{buildroot}%{_usr}/local/bin/
# Set the module(s) to be executable, so that they will be stripped when packaged.
find %{buildroot} -type f -name \*.ko -exec %{__chmod} u+x \{\} \;

%files -n kmod-%{kmod_name} 
/lib/modules/%{kversion}
/etc/depmod.d/kmod-%{kmod_name}.conf
%attr (755, root, root) /etc/sysconfig/modules/%{kmod_name}.modules 
%attr (755, root, root) /usr/local/bin/kgwttm-insmod.sh

%clean
%{__rm} -rf %{buildroot}


%changelog
